package gtu;

import jason.JasonException;
import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.InternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.ListTerm;
import jason.asSyntax.StringTerm;
import jason.asSyntax.StringTermImpl;
import jason.asSyntax.Term;

/**
  
UNSAFE INTERNAL ACTION, TO BE USED ONLY WHEN YOU ARE SURE THAT THE FIRST ARGUMENT IS A SUBSTRING OF THE THIRD ONE, AND YOU WANT TO UNIFY THE SECOND ARGUMENT WITH THE DIFFERENCE BETWEEN THE TWO

**/
public class str_conc extends DefaultInternalAction {

    private static InternalAction singleton = null;
    public static InternalAction create() {
        if (singleton == null) 
            singleton = new str_conc();
        return singleton;
    }

    @Override
    public Object execute(TransitionSystem ts, Unifier un, Term[] args) throws Exception   
{
        
        if (args[0].isString()) {
            // string concat
            if (!args[args.length-1].isVar() && !args[args.length-1].isString()) {
                throw JasonException.createWrongArgument(this,"Last argument '"+args[args.length-1]+"' is not a string nor a variable.");
            }
            String vl1 = ((StringTerm)args[0]).getString();
            String vl3 = ((StringTerm)args[2]).getString();    
            StringBuilder sr = new StringBuilder(vl3);            
            if (vl3.startsWith(vl1))
              sr.delete(0,vl1.length());
               
            return un.unifies(new StringTermImpl(sr.toString()), args[1]);
        } else {
                throw JasonException.createWrongArgument(this,"First argument '"+args[0]+"' must be a list or string.");
        }
    }
}
